# Espressif Wi-Fi Allaince DUT Sigma Agent 
Espressif Wi-Fi Allaince (WFA) Sigma Automation tool suite provides configuration, test control, traffic generation, and results analysis services. WFA test plans, in its entirety, can be executed in a fully automated manner through the WFA distributed Sigma Command Scripts and the Sigma Unified CAPI Console (UCC). Below diagram shows the basic test configuration for infrastructure tests and a physical connection diagram. 

![Alt text](reference/topology.png?raw=true "Title")

### Prerequisites
- Clone & Download SDK and espsigma. 
- Set IDF_PATH (`export IDF_PATH=xxx` in terminal)
- Install python (>=3.6) and requirements. recommended using pyenv:
  - `./tools/setup/setup_pyenv_python.sh`
  - `source ~/.pyenv/activate`
  - You can also install pyenv following: https://github.com/pyenv/pyenv#installation
    
### Installation

1. Connect your Control PC to Sigma UCC control network.    
```
 _____                   ______           _____ 
| UCC  |                |  PC  |         | ESP |  
|______|  ------------- |______| ....... |_____|
           control-net             uart    
```

2. Build & flash "esp_sigma_dut" on ESP module.
```          
~# cd esp_sigma_dut
~# make flash
```      
3. Enable "esp_sigma_ca" service on your Control PC.
```
~# cd esp_sigma_ca
~# python espsigma.py 
```     
4. Start WFA tests on UCC.         

### Supported Sigma programs
11N -STAUT (ESP Wi-Fi Station Under Test)
    
<br>You can also refer [https://www.wi-fi.org/certification/wi-fi-test-suite](https://www.wi-fi.org/certification/wi-fi-test-suite) for WFA test cases and test setup topology.
