from hmac import compare_digest
from xml.dom.pulldom import default_bufsize
from common import gvars, logger

from hmac import compare_digest
from xml.dom.pulldom import default_bufsize
from common import gvars, logger

SUCCESS = gvars.SUCCESS
FAILURE = gvars.FAILURE
QT_FAIL = gvars.QT_FAIL
QT_OK = gvars.QT_OK
def netmask_to_cidr(netmask):
    return sum([bin(int(x)).count('1') for x in netmask.split('.')])

def sta_get_ip(capi_resp):
    capi_resp.data["mask"] = netmask_to_cidr(capi_resp.data["mask"])
    if capi_resp.status == SUCCESS:
        return "{}".format(capi_resp.data["ip"])
    else:
        return QT_FAIL

def sta_get_mac(capi_resp):
    if capi_resp.status == SUCCESS:
        return capi_resp.data
    return QT_FAIL

def sta_set_static_ip(capi_resp):
    if capi_resp.status == SUCCESS:
        return QT_OK
    return QT_FAIL

def sta_associate(capi_resp):
    if capi_resp.status == SUCCESS:
        return QT_OK
    return QT_FAIL

def sta_btm_query(capi_resp):
    if capi_resp.status == FAILURE: 
        return QT_FAIL
    return QT_OK

def sta_disassociate(capi_resp):
    if capi_resp.status == SUCCESS:
        return QT_OK
    return QT_FAIL

def sta_reconnect(capi_resp):
    if capi_resp.status == SUCCESS:
        return QT_OK
    return QT_FAIL

def sta_loopback_server_start(capi_resp):
    if capi_resp.status == SUCCESS:
        return QT_OK
    return QT_FAIL

def sta_loopback_server_stop(capi_resp):
    if capi_resp.status == SUCCESS:
        return QT_OK
    return QT_FAIL

def device_reset(capi_resp):
    if capi_resp.status == SUCCESS:
        return QT_OK
    return QT_FAIL

def sta_set_parameter(capi_resp):
    pmf = capi_resp[1].split("=")[1]
    if gvars.SIGMA_TEST_DATA['pmf'] == "optional" and pmf == "2":
        gvars.SIGMA_TEST_DATA['pmf'] = "mandatory"
    elif gvars.SIGMA_TEST_DATA['pmf'] == "mandatory" and pmf == "1":
        gvars.SIGMA_TEST_DATA['pmf'] = "optional"
    
    #TODO : Figure out if we should call reconnect here.. disconnect and connect here

def sta_set_channel_width():
    #TODO Figure out Sigma Equivalent
    print("Not supported yet")

def sta_enable_power_save(capi_resp):
    #TODO Figure out what data QT actually sends to us for this. For now just enabling it
    return QT_OK
